//+------------------------------------------------------------------+
//|                                           test PositionClose.mq5 |
//+------------------------------------------------------------------+

#include <Expert\Expert.mqh>
#include <Trade\AccountInfo.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\Trade.mqh>
#include <Strings\String.mqh>
#include <Statistics.mqh>
CTrade CT;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
//---
ulong lastTicket;
double Profit=0;
double lastProfit=0;
MqlTradeRequest request;
MqlTradeResult result;
ZeroMemory(request);
ZeroMemory(result);

request.action= TRADE_ACTION_DEAL;
request.magic = 22;
request.symbol= _Symbol;
request.volume= 0.05;
request.price = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
request.deviation=4;
request.action=TRADE_ACTION_DEAL;
request.type_filling= ORDER_FILLING_FOK;
request.type=ORDER_TYPE_BUY;

if(OrderSend(request,result))//|| result.deal==0)
  {
    lastTicket=result.order;
    Print("Do_Order 1 : result.deal: " ,result.deal,"    Ticket:",lastTicket);
  }
  
Sleep (5000);
PositionSelect(_Symbol);
if(     0
    || CT.PositionClose( lastTicket,-1)
  )
   { 
     Print("PositionClose :",Symbol(),"       Ticket Open:", lastTicket );

     ulong Last_Order_Deal=GetLastDealTicket();
     Print("Last_Order_Deal:",Last_Order_Deal);
     if( HistoryDealSelect(Last_Order_Deal))
       {
         Profit= HistoryDealGetDouble(Last_Order_Deal,DEAL_PROFIT); 
         Print("   Last_Order_Deal:",Last_Order_Deal,"   Profit :",Profit);

       } 
    }
   else
     Print("PositionClose 6  not close");
     
}

//+------------------------------------------------------------------+ 
//| Returns the last deal ticket in history or -1                    | 
//+------------------------------------------------------------------+ 
ulong GetLastDealTicket() 
  { 
//--- request history for the last 7 days 
   if(!GetTradeHistory(7)) 
     { 
      //--- notify on unsuccessful call and return -1 
      Print(__FUNCTION__," HistorySelect() returned false"); 
      return -1; 
     } 
//---  
   ulong first_deal,last_deal,deals=HistoryDealsTotal(); 
//--- work with orders if there are any 
   if(deals>0) 
     { 
      Print("Deals = ",deals); 
      first_deal=HistoryDealGetTicket(0); 
      //PrintFormat("first_deal = %d",first_deal); 
      if(deals>1) 
        { 
         last_deal=HistoryDealGetTicket((int)deals-1); 
         PrintFormat("last_deal = %d",last_deal); 
         return last_deal; 
        } 
      return first_deal; 
     } 
//--- no deal found, return -1 
   return -1; 
  } 
//+--------------------------------------------------------------------------+
//| Requests history for the last days and returns false in case of failure  |Trade Functions
//+--------------------------------------------------------------------------+
bool GetTradeHistory(int days)
  {
//--- set a week period to request trade history
   datetime to=TimeCurrent();
   datetime from=to-days*PeriodSeconds(PERIOD_D1);
   ResetLastError();
//--- make a request and check the result
   if(!HistorySelect(from,to))
     {
      Print(__FUNCTION__," HistorySelect=false. Error code=",GetLastError());
      return false;
     }
//--- history received successfully
   return true;
  }
  
